searchNodes=[{"doc":"Customizable file traverser.","ref":"DeepSinker.html","title":"DeepSinker","type":"module"},{"doc":"Create initial state. Examples iex&gt; DeepSinker . new ( [ { &quot;/path/to/dir1&quot; , :dir1 } , { &quot;/path/to/dir2&quot; , :dir2 } ] ) ...&gt; |&gt; is_struct ( DeepSinker ) true iex&gt; DeepSinker . new ( [ { &quot;/path/to/dir1&quot; , :dir1 } , { &quot;/path/to/dir2&quot; , :dir2 } ] , order : :desc ) ...&gt; |&gt; is_struct ( DeepSinker ) true","ref":"DeepSinker.html#new/2","title":"DeepSinker.new/2","type":"function"},{"doc":"Pop file and update state. Examples iex&gt; DeepSinker . new ( [ { &quot;./&quot; , :marker } ] ) ...&gt; |&gt; DeepSinker . next ( ) ...&gt; # {state, {:ok, {filepath, :marker}}} | {state, :done} iex&gt; DeepSinker . new ( [ { &quot;./&quot; , :marker } ] ) ...&gt; |&gt; DeepSinker . next ( ...&gt; handler : fn { path , _marker } -&gt; ...&gt; cond do ...&gt; String . ends_with? ( path , &quot;.git&quot; ) -&gt; :ignore ...&gt; String . contains? ( path , &quot;.&quot; ) -&gt; :file ...&gt; true -&gt; :directory ...&gt; end ...&gt; end ...&gt; ) ...&gt; # {state, {:ok, {filepath, :marker}}} | {state, :done}","ref":"DeepSinker.html#next/2","title":"DeepSinker.next/2","type":"function"},{"doc":"Stream filepaths. Examples iex&gt; DeepSinker . new ( [ { &quot;/path_a&quot; , :a } , { &quot;/path_b&quot; , :b } ] ) ...&gt; # |&gt; DeepSinker.stream() ...&gt; # |&gt; Enum.to_list() ...&gt; # [{&quot;/path_a/1.txt&quot;, :a}, {&quot;/path_a/2.txt, :a} {&quot;/path_b/1.txt, :b}] iex&gt; DeepSinker . new ( [ { &quot;/path_a&quot; , :a } , { &quot;/path_b&quot; , :b } ] ) ...&gt; |&gt; DeepSinker . stream ( ...&gt; handler : fn { path , _marker } -&gt; ...&gt; cond do ...&gt; String . ends_with? ( path , &quot;.git&quot; ) -&gt; :ignore ...&gt; String . contains? ( path , &quot;.&quot; ) -&gt; :file ...&gt; true -&gt; :directory ...&gt; end ...&gt; end ...&gt; ) ...&gt; # [{&quot;/path_a/1.txt&quot;, :a}, {&quot;/path_a/2.txt, :a} {&quot;/path_b/1.txt, :b}]","ref":"DeepSinker.html#stream/2","title":"DeepSinker.stream/2","type":"function"},{"doc":"","ref":"DeepSinker.html#t:handler/0","title":"DeepSinker.handler/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:item/0","title":"DeepSinker.item/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:item_type/0","title":"DeepSinker.item_type/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:marker/0","title":"DeepSinker.marker/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:new_option/0","title":"DeepSinker.new_option/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:next_option/0","title":"DeepSinker.next_option/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:next_result/0","title":"DeepSinker.next_result/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:order/0","title":"DeepSinker.order/0","type":"type"},{"doc":"","ref":"DeepSinker.html#t:path/0","title":"DeepSinker.path/0","type":"type"},{"doc":"State of traversing.","ref":"DeepSinker.html#t:t/0","title":"DeepSinker.t/0","type":"type"},{"doc":"Customizable directory traverser.","ref":"readme.html","title":"DeepSinker","type":"extras"},{"doc":"# Default usage state = DeepSinker . new ( [ { &quot;/path/to/dir1&quot; , :dir1 } , { &quot;/path/to/dir2&quot; , :dir2 } ] ) DeepSinker . next ( state ) # {new_state, {:ok, {path, :dir1 | :dir2}} | :done} # Custom usage state = DeepSinker . new ( [ { &quot;/path/to/dir1&quot; , :dir1 } , { &quot;/path/to/dir2&quot; , :dir2 } ] , order : :desc ) # :asc or :desc DeepSinker . next ( state , handler : fn { path , marker } -&gt; # Below code is default handler but File.dir?/1 consume large time in some env. # cond do # File.dir?(path) -&gt; :directory # true -&gt; :file # end # If you want to avoid File.dir?/1, use this. basename = Path . basename ( path ) cond do basename == &quot;.git&quot; -&gt; :ignore String . contains? ( basename , &quot;.&quot; ) -&gt; :file true -&gt; :directory end end ) # {new_state, {:ok, {path, :dir1 | :dir2}} | :done} # Stream usage state = DeepSinker . new ( [ { &quot;/path/to/dir1&quot; , :dir1 } , { &quot;/path/to/dir2&quot; , :dir2 } ] ) DeepSinker . stream ( state ) |&gt; Enum . to_list ( ) # [{path, :dir1 | :dir2}]","ref":"readme.html#usage","title":"DeepSinker - Usage","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding deep_sinker to your list of dependencies in mix.exs : def deps do [ { :deep_sinker , &quot;~&gt; 2.0.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/deep_sinker .","ref":"readme.html#installation","title":"DeepSinker - Installation","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Changed Change given and return item to {path, marker} from path .","ref":"changelog.html#2-0-0-2023-07-24","title":"Changelog - 2.0.0 - 2023-07-24","type":"extras"},{"doc":"Changed Change to take handler when next/2 instead of new/2 . Fixed Fix type specs.","ref":"changelog.html#1-0-0-2023-06-24","title":"Changelog - 1.0.0 - 2023-06-24","type":"extras"},{"doc":"Fixed Fix traversing.","ref":"changelog.html#0-2-0-2023-04-12","title":"Changelog - 0.2.0 - 2023-04-12","type":"extras"},{"doc":"Fixed Fix document Fix typespec of DeepSinker.stream .","ref":"changelog.html#0-1-2-2023-04-11","title":"Changelog - 0.1.2 - 2023-04-11","type":"extras"},{"doc":"Fixed Add ex_doc .","ref":"changelog.html#0-1-1-2023-04-11","title":"Changelog - 0.1.1 - 2023-04-11","type":"extras"},{"doc":"Added Initial release.","ref":"changelog.html#0-1-0-2023-04-11","title":"Changelog - 0.1.0 - 2023-04-11","type":"extras"}]